# coding: utf-8

"""
    Nucleus API

    Nucleus text analytics APIs from SumUp Analytics. Example and documentation: https://www.sumup.ai/apis/#nucleus-documentation  # noqa: E501

    OpenAPI spec version: v3.2.9
    Contact: info@sumup.ai
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class DatasetInfo(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'dataset': 'str',
        'query': 'str',
        'metadata_selection': 'object',
        'time_period': 'str',
        'period_start': 'str',
        'period_end': 'str',
        'owner_email': 'str'
    }

    attribute_map = {
        'dataset': 'dataset',
        'query': 'query',
        'metadata_selection': 'metadata_selection',
        'time_period': 'time_period',
        'period_start': 'period_start',
        'period_end': 'period_end',
        'owner_email': 'owner_email'
    }

    def __init__(self, dataset=None, query=None, metadata_selection=None, time_period=None, period_start=None, period_end=None, owner_email=None):  # noqa: E501
        """DatasetInfo - a model defined in Swagger"""  # noqa: E501

        self._dataset = None
        self._query = None
        self._metadata_selection = None
        self._time_period = None
        self._period_start = None
        self._period_end = None
        self._owner_email = None
        self.discriminator = None

        self.dataset = dataset
        if query is not None:
            self.query = query
        if metadata_selection is not None:
            self.metadata_selection = metadata_selection
        if time_period is not None:
            self.time_period = time_period
        if period_start is not None:
            self.period_start = period_start
        if period_end is not None:
            self.period_end = period_end
        if owner_email is not None:
            self.owner_email = owner_email

    @property
    def dataset(self):
        """Gets the dataset of this DatasetInfo.  # noqa: E501

        Dataset name.  # noqa: E501

        :return: The dataset of this DatasetInfo.  # noqa: E501
        :rtype: str
        """
        return self._dataset

    @dataset.setter
    def dataset(self, dataset):
        """Sets the dataset of this DatasetInfo.

        Dataset name.  # noqa: E501

        :param dataset: The dataset of this DatasetInfo.  # noqa: E501
        :type: str
        """
        if dataset is None:
            raise ValueError("Invalid value for `dataset`, must not be `None`")  # noqa: E501

        self._dataset = dataset

    @property
    def query(self):
        """Gets the query of this DatasetInfo.  # noqa: E501

        Dataset-language-specific fulltext query, using mysql MATCH boolean query format. Example: \"(word1 OR word2) AND (word3 OR word4)\"   # noqa: E501

        :return: The query of this DatasetInfo.  # noqa: E501
        :rtype: str
        """
        return self._query

    @query.setter
    def query(self, query):
        """Sets the query of this DatasetInfo.

        Dataset-language-specific fulltext query, using mysql MATCH boolean query format. Example: \"(word1 OR word2) AND (word3 OR word4)\"   # noqa: E501

        :param query: The query of this DatasetInfo.  # noqa: E501
        :type: str
        """

        self._query = query

    @property
    def metadata_selection(self):
        """Gets the metadata_selection of this DatasetInfo.  # noqa: E501

        JSON object specifying metadata-based queries on the dataset, of type {\"metadata_field\": \"selected_values\"}  # noqa: E501

        :return: The metadata_selection of this DatasetInfo.  # noqa: E501
        :rtype: object
        """
        return self._metadata_selection

    @metadata_selection.setter
    def metadata_selection(self, metadata_selection):
        """Sets the metadata_selection of this DatasetInfo.

        JSON object specifying metadata-based queries on the dataset, of type {\"metadata_field\": \"selected_values\"}  # noqa: E501

        :param metadata_selection: The metadata_selection of this DatasetInfo.  # noqa: E501
        :type: object
        """

        self._metadata_selection = metadata_selection

    @property
    def time_period(self):
        """Gets the time_period of this DatasetInfo.  # noqa: E501

        Alternative 1: Time period selection  # noqa: E501

        :return: The time_period of this DatasetInfo.  # noqa: E501
        :rtype: str
        """
        return self._time_period

    @time_period.setter
    def time_period(self, time_period):
        """Sets the time_period of this DatasetInfo.

        Alternative 1: Time period selection  # noqa: E501

        :param time_period: The time_period of this DatasetInfo.  # noqa: E501
        :type: str
        """

        self._time_period = time_period

    @property
    def period_start(self):
        """Gets the period_start of this DatasetInfo.  # noqa: E501

        Alternative 2: Start date for the period to analyze within the dataset. Format: \"YYYY-MM-DD HH:MM:SS\"   # noqa: E501

        :return: The period_start of this DatasetInfo.  # noqa: E501
        :rtype: str
        """
        return self._period_start

    @period_start.setter
    def period_start(self, period_start):
        """Sets the period_start of this DatasetInfo.

        Alternative 2: Start date for the period to analyze within the dataset. Format: \"YYYY-MM-DD HH:MM:SS\"   # noqa: E501

        :param period_start: The period_start of this DatasetInfo.  # noqa: E501
        :type: str
        """

        self._period_start = period_start

    @property
    def period_end(self):
        """Gets the period_end of this DatasetInfo.  # noqa: E501

        Alternative 2: End date for the period to analyze within the dataset. Format: \"YYYY-MM-DD HH:MM:SS\"   # noqa: E501

        :return: The period_end of this DatasetInfo.  # noqa: E501
        :rtype: str
        """
        return self._period_end

    @period_end.setter
    def period_end(self, period_end):
        """Sets the period_end of this DatasetInfo.

        Alternative 2: End date for the period to analyze within the dataset. Format: \"YYYY-MM-DD HH:MM:SS\"   # noqa: E501

        :param period_end: The period_end of this DatasetInfo.  # noqa: E501
        :type: str
        """

        self._period_end = period_end

    @property
    def owner_email(self):
        """Gets the owner_email of this DatasetInfo.  # noqa: E501

        Has to be specified to access a shared dataset that is owned by another user  # noqa: E501

        :return: The owner_email of this DatasetInfo.  # noqa: E501
        :rtype: str
        """
        return self._owner_email

    @owner_email.setter
    def owner_email(self, owner_email):
        """Sets the owner_email of this DatasetInfo.

        Has to be specified to access a shared dataset that is owned by another user  # noqa: E501

        :param owner_email: The owner_email of this DatasetInfo.  # noqa: E501
        :type: str
        """

        self._owner_email = owner_email

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(DatasetInfo, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DatasetInfo):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
