# coding: utf-8

"""
    Nucleus API

    Nucleus text analytics APIs from SumUp Analytics. Example and documentation: https://www.sumup.ai/apis/#nucleus-documentation  # noqa: E501

    OpenAPI spec version: v3.2.9
    Contact: info@sumup.ai
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class DocDisplayL1RespModel(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'total_blocks': 'int',
        'block': 'int',
        'title': 'str',
        'sourceid': 'str',
        'attribute': 'object'
    }

    attribute_map = {
        'total_blocks': 'total_blocks',
        'block': 'block',
        'title': 'title',
        'sourceid': 'sourceid',
        'attribute': 'attribute'
    }

    def __init__(self, total_blocks=None, block=None, title=None, sourceid=None, attribute=None):  # noqa: E501
        """DocDisplayL1RespModel - a model defined in Swagger"""  # noqa: E501

        self._total_blocks = None
        self._block = None
        self._title = None
        self._sourceid = None
        self._attribute = None
        self.discriminator = None

        if total_blocks is not None:
            self.total_blocks = total_blocks
        if block is not None:
            self.block = block
        if title is not None:
            self.title = title
        if sourceid is not None:
            self.sourceid = sourceid
        if attribute is not None:
            self.attribute = attribute

    @property
    def total_blocks(self):
        """Gets the total_blocks of this DocDisplayL1RespModel.  # noqa: E501

        Total number of blocks. Each block has 100 documents.   # noqa: E501

        :return: The total_blocks of this DocDisplayL1RespModel.  # noqa: E501
        :rtype: int
        """
        return self._total_blocks

    @total_blocks.setter
    def total_blocks(self, total_blocks):
        """Sets the total_blocks of this DocDisplayL1RespModel.

        Total number of blocks. Each block has 100 documents.   # noqa: E501

        :param total_blocks: The total_blocks of this DocDisplayL1RespModel.  # noqa: E501
        :type: int
        """

        self._total_blocks = total_blocks

    @property
    def block(self):
        """Gets the block of this DocDisplayL1RespModel.  # noqa: E501

        The block number of the documents being returned  # noqa: E501

        :return: The block of this DocDisplayL1RespModel.  # noqa: E501
        :rtype: int
        """
        return self._block

    @block.setter
    def block(self, block):
        """Sets the block of this DocDisplayL1RespModel.

        The block number of the documents being returned  # noqa: E501

        :param block: The block of this DocDisplayL1RespModel.  # noqa: E501
        :type: int
        """

        self._block = block

    @property
    def title(self):
        """Gets the title of this DocDisplayL1RespModel.  # noqa: E501

        Document title  # noqa: E501

        :return: The title of this DocDisplayL1RespModel.  # noqa: E501
        :rtype: str
        """
        return self._title

    @title.setter
    def title(self, title):
        """Sets the title of this DocDisplayL1RespModel.

        Document title  # noqa: E501

        :param title: The title of this DocDisplayL1RespModel.  # noqa: E501
        :type: str
        """

        self._title = title

    @property
    def sourceid(self):
        """Gets the sourceid of this DocDisplayL1RespModel.  # noqa: E501

        Document ID  # noqa: E501

        :return: The sourceid of this DocDisplayL1RespModel.  # noqa: E501
        :rtype: str
        """
        return self._sourceid

    @sourceid.setter
    def sourceid(self, sourceid):
        """Sets the sourceid of this DocDisplayL1RespModel.

        Document ID  # noqa: E501

        :param sourceid: The sourceid of this DocDisplayL1RespModel.  # noqa: E501
        :type: str
        """

        self._sourceid = sourceid

    @property
    def attribute(self):
        """Gets the attribute of this DocDisplayL1RespModel.  # noqa: E501

        JSON containing document metadata key:value pairs (eg. author, time..)  # noqa: E501

        :return: The attribute of this DocDisplayL1RespModel.  # noqa: E501
        :rtype: object
        """
        return self._attribute

    @attribute.setter
    def attribute(self, attribute):
        """Sets the attribute of this DocDisplayL1RespModel.

        JSON containing document metadata key:value pairs (eg. author, time..)  # noqa: E501

        :param attribute: The attribute of this DocDisplayL1RespModel.  # noqa: E501
        :type: object
        """

        self._attribute = attribute

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(DocDisplayL1RespModel, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DocDisplayL1RespModel):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
