# coding: utf-8

"""
    Nucleus API

    Nucleus text analytics APIs from SumUp Analytics. Example and documentation: https://www.sumup.ai/apis/#nucleus-documentation  # noqa: E501

    OpenAPI spec version: v3.2.9
    Contact: info@sumup.ai
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class DocumentNoveltyModel(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'dataset': 'str',
        'query': 'str',
        'custom_stop_words': 'list[str]',
        'num_days_back': 'int',
        'novelty_threshold': 'float',
        'metadata_selection': 'object',
        'time_period': 'str',
        'period_start': 'str',
        'period_end': 'str',
        'excluded_docs': 'list[str]',
        'short_sentence_length': 'int',
        'long_sentence_length': 'int',
        'remove_redundancies': 'bool'
    }

    attribute_map = {
        'dataset': 'dataset',
        'query': 'query',
        'custom_stop_words': 'custom_stop_words',
        'num_days_back': 'num_days_back',
        'novelty_threshold': 'novelty_threshold',
        'metadata_selection': 'metadata_selection',
        'time_period': 'time_period',
        'period_start': 'period_start',
        'period_end': 'period_end',
        'excluded_docs': 'excluded_docs',
        'short_sentence_length': 'short_sentence_length',
        'long_sentence_length': 'long_sentence_length',
        'remove_redundancies': 'remove_redundancies'
    }

    def __init__(self, dataset=None, query=None, custom_stop_words=None, num_days_back=None, novelty_threshold=None, metadata_selection=None, time_period=None, period_start=None, period_end=None, excluded_docs=None, short_sentence_length=None, long_sentence_length=None, remove_redundancies=False):  # noqa: E501
        """DocumentNoveltyModel - a model defined in Swagger"""  # noqa: E501

        self._dataset = None
        self._query = None
        self._custom_stop_words = None
        self._num_days_back = None
        self._novelty_threshold = None
        self._metadata_selection = None
        self._time_period = None
        self._period_start = None
        self._period_end = None
        self._excluded_docs = None
        self._short_sentence_length = None
        self._long_sentence_length = None
        self._remove_redundancies = None
        self.discriminator = None

        self.dataset = dataset
        if query is not None:
            self.query = query
        if custom_stop_words is not None:
            self.custom_stop_words = custom_stop_words
        if num_days_back is not None:
            self.num_days_back = num_days_back
        if novelty_threshold is not None:
            self.novelty_threshold = novelty_threshold
        if metadata_selection is not None:
            self.metadata_selection = metadata_selection
        if time_period is not None:
            self.time_period = time_period
        if period_start is not None:
            self.period_start = period_start
        if period_end is not None:
            self.period_end = period_end
        if excluded_docs is not None:
            self.excluded_docs = excluded_docs
        if short_sentence_length is not None:
            self.short_sentence_length = short_sentence_length
        if long_sentence_length is not None:
            self.long_sentence_length = long_sentence_length
        if remove_redundancies is not None:
            self.remove_redundancies = remove_redundancies

    @property
    def dataset(self):
        """Gets the dataset of this DocumentNoveltyModel.  # noqa: E501

        Dataset name.  # noqa: E501

        :return: The dataset of this DocumentNoveltyModel.  # noqa: E501
        :rtype: str
        """
        return self._dataset

    @dataset.setter
    def dataset(self, dataset):
        """Sets the dataset of this DocumentNoveltyModel.

        Dataset name.  # noqa: E501

        :param dataset: The dataset of this DocumentNoveltyModel.  # noqa: E501
        :type: str
        """
        if dataset is None:
            raise ValueError("Invalid value for `dataset`, must not be `None`")  # noqa: E501

        self._dataset = dataset

    @property
    def query(self):
        """Gets the query of this DocumentNoveltyModel.  # noqa: E501

        Dataset-language-specific fulltext query, using mysql MATCH boolean query format. Example: \"(word1 OR word2) AND (word3 OR word4)\"   # noqa: E501

        :return: The query of this DocumentNoveltyModel.  # noqa: E501
        :rtype: str
        """
        return self._query

    @query.setter
    def query(self, query):
        """Sets the query of this DocumentNoveltyModel.

        Dataset-language-specific fulltext query, using mysql MATCH boolean query format. Example: \"(word1 OR word2) AND (word3 OR word4)\"   # noqa: E501

        :param query: The query of this DocumentNoveltyModel.  # noqa: E501
        :type: str
        """

        self._query = query

    @property
    def custom_stop_words(self):
        """Gets the custom_stop_words of this DocumentNoveltyModel.  # noqa: E501


        :return: The custom_stop_words of this DocumentNoveltyModel.  # noqa: E501
        :rtype: list[str]
        """
        return self._custom_stop_words

    @custom_stop_words.setter
    def custom_stop_words(self, custom_stop_words):
        """Sets the custom_stop_words of this DocumentNoveltyModel.


        :param custom_stop_words: The custom_stop_words of this DocumentNoveltyModel.  # noqa: E501
        :type: list[str]
        """

        self._custom_stop_words = custom_stop_words

    @property
    def num_days_back(self):
        """Gets the num_days_back of this DocumentNoveltyModel.  # noqa: E501

        Number of days from the latest date of the dataset, which are considered as foreground for the novelty analysis.  # noqa: E501

        :return: The num_days_back of this DocumentNoveltyModel.  # noqa: E501
        :rtype: int
        """
        return self._num_days_back

    @num_days_back.setter
    def num_days_back(self, num_days_back):
        """Sets the num_days_back of this DocumentNoveltyModel.

        Number of days from the latest date of the dataset, which are considered as foreground for the novelty analysis.  # noqa: E501

        :param num_days_back: The num_days_back of this DocumentNoveltyModel.  # noqa: E501
        :type: int
        """

        self._num_days_back = num_days_back

    @property
    def novelty_threshold(self):
        """Gets the novelty_threshold of this DocumentNoveltyModel.  # noqa: E501

        Value of novelty of a document above which a document is considered novel. This value should be between 0 and 1 and reflects the percentage of the document information unexplained by the background.  # noqa: E501

        :return: The novelty_threshold of this DocumentNoveltyModel.  # noqa: E501
        :rtype: float
        """
        return self._novelty_threshold

    @novelty_threshold.setter
    def novelty_threshold(self, novelty_threshold):
        """Sets the novelty_threshold of this DocumentNoveltyModel.

        Value of novelty of a document above which a document is considered novel. This value should be between 0 and 1 and reflects the percentage of the document information unexplained by the background.  # noqa: E501

        :param novelty_threshold: The novelty_threshold of this DocumentNoveltyModel.  # noqa: E501
        :type: float
        """

        self._novelty_threshold = novelty_threshold

    @property
    def metadata_selection(self):
        """Gets the metadata_selection of this DocumentNoveltyModel.  # noqa: E501

        JSON object specifying metadata-based queries on the dataset, of type {\"metadata_field\": \"selected_values\"}  # noqa: E501

        :return: The metadata_selection of this DocumentNoveltyModel.  # noqa: E501
        :rtype: object
        """
        return self._metadata_selection

    @metadata_selection.setter
    def metadata_selection(self, metadata_selection):
        """Sets the metadata_selection of this DocumentNoveltyModel.

        JSON object specifying metadata-based queries on the dataset, of type {\"metadata_field\": \"selected_values\"}  # noqa: E501

        :param metadata_selection: The metadata_selection of this DocumentNoveltyModel.  # noqa: E501
        :type: object
        """

        self._metadata_selection = metadata_selection

    @property
    def time_period(self):
        """Gets the time_period of this DocumentNoveltyModel.  # noqa: E501

        Alternative 1: Time period selection for the period considered as background for the novelty analysis  # noqa: E501

        :return: The time_period of this DocumentNoveltyModel.  # noqa: E501
        :rtype: str
        """
        return self._time_period

    @time_period.setter
    def time_period(self, time_period):
        """Sets the time_period of this DocumentNoveltyModel.

        Alternative 1: Time period selection for the period considered as background for the novelty analysis  # noqa: E501

        :param time_period: The time_period of this DocumentNoveltyModel.  # noqa: E501
        :type: str
        """

        self._time_period = time_period

    @property
    def period_start(self):
        """Gets the period_start of this DocumentNoveltyModel.  # noqa: E501

        Alternative 2: Start date for the period considered as background for the novelty analysis. Format: \"YYYY-MM-DD\"   # noqa: E501

        :return: The period_start of this DocumentNoveltyModel.  # noqa: E501
        :rtype: str
        """
        return self._period_start

    @period_start.setter
    def period_start(self, period_start):
        """Sets the period_start of this DocumentNoveltyModel.

        Alternative 2: Start date for the period considered as background for the novelty analysis. Format: \"YYYY-MM-DD\"   # noqa: E501

        :param period_start: The period_start of this DocumentNoveltyModel.  # noqa: E501
        :type: str
        """

        self._period_start = period_start

    @property
    def period_end(self):
        """Gets the period_end of this DocumentNoveltyModel.  # noqa: E501

        Alternative 2: End date for the period considered as background for the novelty analysis. Format: \"YYYY-MM-DD HH:MM:SS\"   # noqa: E501

        :return: The period_end of this DocumentNoveltyModel.  # noqa: E501
        :rtype: str
        """
        return self._period_end

    @period_end.setter
    def period_end(self, period_end):
        """Sets the period_end of this DocumentNoveltyModel.

        Alternative 2: End date for the period considered as background for the novelty analysis. Format: \"YYYY-MM-DD HH:MM:SS\"   # noqa: E501

        :param period_end: The period_end of this DocumentNoveltyModel.  # noqa: E501
        :type: str
        """

        self._period_end = period_end

    @property
    def excluded_docs(self):
        """Gets the excluded_docs of this DocumentNoveltyModel.  # noqa: E501


        :return: The excluded_docs of this DocumentNoveltyModel.  # noqa: E501
        :rtype: list[str]
        """
        return self._excluded_docs

    @excluded_docs.setter
    def excluded_docs(self, excluded_docs):
        """Sets the excluded_docs of this DocumentNoveltyModel.


        :param excluded_docs: The excluded_docs of this DocumentNoveltyModel.  # noqa: E501
        :type: list[str]
        """

        self._excluded_docs = excluded_docs

    @property
    def short_sentence_length(self):
        """Gets the short_sentence_length of this DocumentNoveltyModel.  # noqa: E501

        The sentence length (in number of words) below which a sentence is excluded from novelty analysis.  # noqa: E501

        :return: The short_sentence_length of this DocumentNoveltyModel.  # noqa: E501
        :rtype: int
        """
        return self._short_sentence_length

    @short_sentence_length.setter
    def short_sentence_length(self, short_sentence_length):
        """Sets the short_sentence_length of this DocumentNoveltyModel.

        The sentence length (in number of words) below which a sentence is excluded from novelty analysis.  # noqa: E501

        :param short_sentence_length: The short_sentence_length of this DocumentNoveltyModel.  # noqa: E501
        :type: int
        """

        self._short_sentence_length = short_sentence_length

    @property
    def long_sentence_length(self):
        """Gets the long_sentence_length of this DocumentNoveltyModel.  # noqa: E501

        The sentence length (in number of words) beyond which a sentence is excluded from novelty analysis.  # noqa: E501

        :return: The long_sentence_length of this DocumentNoveltyModel.  # noqa: E501
        :rtype: int
        """
        return self._long_sentence_length

    @long_sentence_length.setter
    def long_sentence_length(self, long_sentence_length):
        """Sets the long_sentence_length of this DocumentNoveltyModel.

        The sentence length (in number of words) beyond which a sentence is excluded from novelty analysis.  # noqa: E501

        :param long_sentence_length: The long_sentence_length of this DocumentNoveltyModel.  # noqa: E501
        :type: int
        """

        self._long_sentence_length = long_sentence_length

    @property
    def remove_redundancies(self):
        """Gets the remove_redundancies of this DocumentNoveltyModel.  # noqa: E501

        If True, this option removes quasi-duplicates from the analysis. A quasi-duplicate would have the same NLP representation, but not necessarily the exact same text.  # noqa: E501

        :return: The remove_redundancies of this DocumentNoveltyModel.  # noqa: E501
        :rtype: bool
        """
        return self._remove_redundancies

    @remove_redundancies.setter
    def remove_redundancies(self, remove_redundancies):
        """Sets the remove_redundancies of this DocumentNoveltyModel.

        If True, this option removes quasi-duplicates from the analysis. A quasi-duplicate would have the same NLP representation, but not necessarily the exact same text.  # noqa: E501

        :param remove_redundancies: The remove_redundancies of this DocumentNoveltyModel.  # noqa: E501
        :type: bool
        """

        self._remove_redundancies = remove_redundancies

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(DocumentNoveltyModel, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DocumentNoveltyModel):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
