# coding: utf-8

"""
    Nucleus API

    Nucleus text analytics APIs from SumUp Analytics. Example and documentation: https://www.sumup.ai/apis/#nucleus-documentation  # noqa: E501

    OpenAPI spec version: v3.2.9
    Contact: info@sumup.ai
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class MetadataHistogram(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'dataset': 'str',
        'metadata_column': 'object',
        'metadata_selection': 'object',
        'time_period': 'str',
        'query': 'str'
    }

    attribute_map = {
        'dataset': 'dataset',
        'metadata_column': 'metadata_column',
        'metadata_selection': 'metadata_selection',
        'time_period': 'time_period',
        'query': 'query'
    }

    def __init__(self, dataset=None, metadata_column=None, metadata_selection=None, time_period='1M', query=None):  # noqa: E501
        """MetadataHistogram - a model defined in Swagger"""  # noqa: E501

        self._dataset = None
        self._metadata_column = None
        self._metadata_selection = None
        self._time_period = None
        self._query = None
        self.discriminator = None

        self.dataset = dataset
        self.metadata_column = metadata_column
        if metadata_selection is not None:
            self.metadata_selection = metadata_selection
        if time_period is not None:
            self.time_period = time_period
        if query is not None:
            self.query = query

    @property
    def dataset(self):
        """Gets the dataset of this MetadataHistogram.  # noqa: E501

        Dataset name.  # noqa: E501

        :return: The dataset of this MetadataHistogram.  # noqa: E501
        :rtype: str
        """
        return self._dataset

    @dataset.setter
    def dataset(self, dataset):
        """Sets the dataset of this MetadataHistogram.

        Dataset name.  # noqa: E501

        :param dataset: The dataset of this MetadataHistogram.  # noqa: E501
        :type: str
        """
        if dataset is None:
            raise ValueError("Invalid value for `dataset`, must not be `None`")  # noqa: E501

        self._dataset = dataset

    @property
    def metadata_column(self):
        """Gets the metadata_column of this MetadataHistogram.  # noqa: E501

        Pivot column. Api will return document count for each different value of metadata_column.  # noqa: E501

        :return: The metadata_column of this MetadataHistogram.  # noqa: E501
        :rtype: object
        """
        return self._metadata_column

    @metadata_column.setter
    def metadata_column(self, metadata_column):
        """Sets the metadata_column of this MetadataHistogram.

        Pivot column. Api will return document count for each different value of metadata_column.  # noqa: E501

        :param metadata_column: The metadata_column of this MetadataHistogram.  # noqa: E501
        :type: object
        """
        if metadata_column is None:
            raise ValueError("Invalid value for `metadata_column`, must not be `None`")  # noqa: E501

        self._metadata_column = metadata_column

    @property
    def metadata_selection(self):
        """Gets the metadata_selection of this MetadataHistogram.  # noqa: E501

        JSON object specifying pre-existing filters on the dataset, of type {\"metadata_field\": \"selected_values\"}  # noqa: E501

        :return: The metadata_selection of this MetadataHistogram.  # noqa: E501
        :rtype: object
        """
        return self._metadata_selection

    @metadata_selection.setter
    def metadata_selection(self, metadata_selection):
        """Sets the metadata_selection of this MetadataHistogram.

        JSON object specifying pre-existing filters on the dataset, of type {\"metadata_field\": \"selected_values\"}  # noqa: E501

        :param metadata_selection: The metadata_selection of this MetadataHistogram.  # noqa: E501
        :type: object
        """

        self._metadata_selection = metadata_selection

    @property
    def time_period(self):
        """Gets the time_period of this MetadataHistogram.  # noqa: E501

        Time period of the datafeed if any  # noqa: E501

        :return: The time_period of this MetadataHistogram.  # noqa: E501
        :rtype: str
        """
        return self._time_period

    @time_period.setter
    def time_period(self, time_period):
        """Sets the time_period of this MetadataHistogram.

        Time period of the datafeed if any  # noqa: E501

        :param time_period: The time_period of this MetadataHistogram.  # noqa: E501
        :type: str
        """

        self._time_period = time_period

    @property
    def query(self):
        """Gets the query of this MetadataHistogram.  # noqa: E501

        The fulltext query\"   # noqa: E501

        :return: The query of this MetadataHistogram.  # noqa: E501
        :rtype: str
        """
        return self._query

    @query.setter
    def query(self, query):
        """Sets the query of this MetadataHistogram.

        The fulltext query\"   # noqa: E501

        :param query: The query of this MetadataHistogram.  # noqa: E501
        :type: str
        """

        self._query = query

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(MetadataHistogram, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, MetadataHistogram):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
