# coding: utf-8

"""
    Nucleus API

    Nucleus text analytics APIs from SumUp Analytics. Example and documentation: https://www.sumup.ai/apis/#nucleus-documentation  # noqa: E501

    OpenAPI spec version: v3.2.9
    Contact: info@sumup.ai
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class TopicSummaryModel(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'dataset': 'str',
        'query': 'str',
        'custom_stop_words': 'list[str]',
        'num_topics': 'int',
        'num_keywords': 'int',
        'metadata_selection': 'object',
        'time_period': 'str',
        'period_start': 'str',
        'period_end': 'str',
        'summary_length': 'int',
        'context_amount': 'int',
        'num_docs': 'int',
        'excluded_docs': 'list[str]',
        'remove_redundancies': 'bool'
    }

    attribute_map = {
        'dataset': 'dataset',
        'query': 'query',
        'custom_stop_words': 'custom_stop_words',
        'num_topics': 'num_topics',
        'num_keywords': 'num_keywords',
        'metadata_selection': 'metadata_selection',
        'time_period': 'time_period',
        'period_start': 'period_start',
        'period_end': 'period_end',
        'summary_length': 'summary_length',
        'context_amount': 'context_amount',
        'num_docs': 'num_docs',
        'excluded_docs': 'excluded_docs',
        'remove_redundancies': 'remove_redundancies'
    }

    def __init__(self, dataset=None, query=None, custom_stop_words=None, num_topics=None, num_keywords=None, metadata_selection=None, time_period=None, period_start=None, period_end=None, summary_length=None, context_amount=None, num_docs=None, excluded_docs=None, remove_redundancies=True):  # noqa: E501
        """TopicSummaryModel - a model defined in Swagger"""  # noqa: E501

        self._dataset = None
        self._query = None
        self._custom_stop_words = None
        self._num_topics = None
        self._num_keywords = None
        self._metadata_selection = None
        self._time_period = None
        self._period_start = None
        self._period_end = None
        self._summary_length = None
        self._context_amount = None
        self._num_docs = None
        self._excluded_docs = None
        self._remove_redundancies = None
        self.discriminator = None

        self.dataset = dataset
        if query is not None:
            self.query = query
        if custom_stop_words is not None:
            self.custom_stop_words = custom_stop_words
        if num_topics is not None:
            self.num_topics = num_topics
        if num_keywords is not None:
            self.num_keywords = num_keywords
        if metadata_selection is not None:
            self.metadata_selection = metadata_selection
        if time_period is not None:
            self.time_period = time_period
        if period_start is not None:
            self.period_start = period_start
        if period_end is not None:
            self.period_end = period_end
        if summary_length is not None:
            self.summary_length = summary_length
        if context_amount is not None:
            self.context_amount = context_amount
        if num_docs is not None:
            self.num_docs = num_docs
        if excluded_docs is not None:
            self.excluded_docs = excluded_docs
        if remove_redundancies is not None:
            self.remove_redundancies = remove_redundancies

    @property
    def dataset(self):
        """Gets the dataset of this TopicSummaryModel.  # noqa: E501

        Dataset name.  # noqa: E501

        :return: The dataset of this TopicSummaryModel.  # noqa: E501
        :rtype: str
        """
        return self._dataset

    @dataset.setter
    def dataset(self, dataset):
        """Sets the dataset of this TopicSummaryModel.

        Dataset name.  # noqa: E501

        :param dataset: The dataset of this TopicSummaryModel.  # noqa: E501
        :type: str
        """
        if dataset is None:
            raise ValueError("Invalid value for `dataset`, must not be `None`")  # noqa: E501

        self._dataset = dataset

    @property
    def query(self):
        """Gets the query of this TopicSummaryModel.  # noqa: E501

        Dataset-language-specific fulltext query, using mysql MATCH boolean query format. Example: \"(word1 OR word2) AND (word3 OR word4)\"   # noqa: E501

        :return: The query of this TopicSummaryModel.  # noqa: E501
        :rtype: str
        """
        return self._query

    @query.setter
    def query(self, query):
        """Sets the query of this TopicSummaryModel.

        Dataset-language-specific fulltext query, using mysql MATCH boolean query format. Example: \"(word1 OR word2) AND (word3 OR word4)\"   # noqa: E501

        :param query: The query of this TopicSummaryModel.  # noqa: E501
        :type: str
        """

        self._query = query

    @property
    def custom_stop_words(self):
        """Gets the custom_stop_words of this TopicSummaryModel.  # noqa: E501


        :return: The custom_stop_words of this TopicSummaryModel.  # noqa: E501
        :rtype: list[str]
        """
        return self._custom_stop_words

    @custom_stop_words.setter
    def custom_stop_words(self, custom_stop_words):
        """Sets the custom_stop_words of this TopicSummaryModel.


        :param custom_stop_words: The custom_stop_words of this TopicSummaryModel.  # noqa: E501
        :type: list[str]
        """

        self._custom_stop_words = custom_stop_words

    @property
    def num_topics(self):
        """Gets the num_topics of this TopicSummaryModel.  # noqa: E501

        Number of topics to be extracted from the dataset and summarized.  # noqa: E501

        :return: The num_topics of this TopicSummaryModel.  # noqa: E501
        :rtype: int
        """
        return self._num_topics

    @num_topics.setter
    def num_topics(self, num_topics):
        """Sets the num_topics of this TopicSummaryModel.

        Number of topics to be extracted from the dataset and summarized.  # noqa: E501

        :param num_topics: The num_topics of this TopicSummaryModel.  # noqa: E501
        :type: int
        """

        self._num_topics = num_topics

    @property
    def num_keywords(self):
        """Gets the num_keywords of this TopicSummaryModel.  # noqa: E501

        Number of keywords per topic that is extracted from the dataset.  # noqa: E501

        :return: The num_keywords of this TopicSummaryModel.  # noqa: E501
        :rtype: int
        """
        return self._num_keywords

    @num_keywords.setter
    def num_keywords(self, num_keywords):
        """Sets the num_keywords of this TopicSummaryModel.

        Number of keywords per topic that is extracted from the dataset.  # noqa: E501

        :param num_keywords: The num_keywords of this TopicSummaryModel.  # noqa: E501
        :type: int
        """

        self._num_keywords = num_keywords

    @property
    def metadata_selection(self):
        """Gets the metadata_selection of this TopicSummaryModel.  # noqa: E501

        JSON object specifying metadata-based queries on the dataset, of type {\"metadata_field\": \"selected_values\"}  # noqa: E501

        :return: The metadata_selection of this TopicSummaryModel.  # noqa: E501
        :rtype: object
        """
        return self._metadata_selection

    @metadata_selection.setter
    def metadata_selection(self, metadata_selection):
        """Sets the metadata_selection of this TopicSummaryModel.

        JSON object specifying metadata-based queries on the dataset, of type {\"metadata_field\": \"selected_values\"}  # noqa: E501

        :param metadata_selection: The metadata_selection of this TopicSummaryModel.  # noqa: E501
        :type: object
        """

        self._metadata_selection = metadata_selection

    @property
    def time_period(self):
        """Gets the time_period of this TopicSummaryModel.  # noqa: E501

        Alternative 1: Time period selection  # noqa: E501

        :return: The time_period of this TopicSummaryModel.  # noqa: E501
        :rtype: str
        """
        return self._time_period

    @time_period.setter
    def time_period(self, time_period):
        """Sets the time_period of this TopicSummaryModel.

        Alternative 1: Time period selection  # noqa: E501

        :param time_period: The time_period of this TopicSummaryModel.  # noqa: E501
        :type: str
        """

        self._time_period = time_period

    @property
    def period_start(self):
        """Gets the period_start of this TopicSummaryModel.  # noqa: E501

        Alternative 2: Start date for the period to analyze within the dataset. Format: \"YYYY-MM-DD\"   # noqa: E501

        :return: The period_start of this TopicSummaryModel.  # noqa: E501
        :rtype: str
        """
        return self._period_start

    @period_start.setter
    def period_start(self, period_start):
        """Sets the period_start of this TopicSummaryModel.

        Alternative 2: Start date for the period to analyze within the dataset. Format: \"YYYY-MM-DD\"   # noqa: E501

        :param period_start: The period_start of this TopicSummaryModel.  # noqa: E501
        :type: str
        """

        self._period_start = period_start

    @property
    def period_end(self):
        """Gets the period_end of this TopicSummaryModel.  # noqa: E501

        Alternative 2: End date for the period to analyze within the dataset. Format: \"YYYY-MM-DD\"   # noqa: E501

        :return: The period_end of this TopicSummaryModel.  # noqa: E501
        :rtype: str
        """
        return self._period_end

    @period_end.setter
    def period_end(self, period_end):
        """Sets the period_end of this TopicSummaryModel.

        Alternative 2: End date for the period to analyze within the dataset. Format: \"YYYY-MM-DD\"   # noqa: E501

        :param period_end: The period_end of this TopicSummaryModel.  # noqa: E501
        :type: str
        """

        self._period_end = period_end

    @property
    def summary_length(self):
        """Gets the summary_length of this TopicSummaryModel.  # noqa: E501

        The maximum number of bullet points a user wants to see in each topic summary.  # noqa: E501

        :return: The summary_length of this TopicSummaryModel.  # noqa: E501
        :rtype: int
        """
        return self._summary_length

    @summary_length.setter
    def summary_length(self, summary_length):
        """Sets the summary_length of this TopicSummaryModel.

        The maximum number of bullet points a user wants to see in each topic summary.  # noqa: E501

        :param summary_length: The summary_length of this TopicSummaryModel.  # noqa: E501
        :type: int
        """

        self._summary_length = summary_length

    @property
    def context_amount(self):
        """Gets the context_amount of this TopicSummaryModel.  # noqa: E501

        The number of sentences surrounding key summary sentences in the documents that they come from.  # noqa: E501

        :return: The context_amount of this TopicSummaryModel.  # noqa: E501
        :rtype: int
        """
        return self._context_amount

    @context_amount.setter
    def context_amount(self, context_amount):
        """Sets the context_amount of this TopicSummaryModel.

        The number of sentences surrounding key summary sentences in the documents that they come from.  # noqa: E501

        :param context_amount: The context_amount of this TopicSummaryModel.  # noqa: E501
        :type: int
        """

        self._context_amount = context_amount

    @property
    def num_docs(self):
        """Gets the num_docs of this TopicSummaryModel.  # noqa: E501

        The maximum number of key documents to use for summarization.  # noqa: E501

        :return: The num_docs of this TopicSummaryModel.  # noqa: E501
        :rtype: int
        """
        return self._num_docs

    @num_docs.setter
    def num_docs(self, num_docs):
        """Sets the num_docs of this TopicSummaryModel.

        The maximum number of key documents to use for summarization.  # noqa: E501

        :param num_docs: The num_docs of this TopicSummaryModel.  # noqa: E501
        :type: int
        """

        self._num_docs = num_docs

    @property
    def excluded_docs(self):
        """Gets the excluded_docs of this TopicSummaryModel.  # noqa: E501


        :return: The excluded_docs of this TopicSummaryModel.  # noqa: E501
        :rtype: list[str]
        """
        return self._excluded_docs

    @excluded_docs.setter
    def excluded_docs(self, excluded_docs):
        """Sets the excluded_docs of this TopicSummaryModel.


        :param excluded_docs: The excluded_docs of this TopicSummaryModel.  # noqa: E501
        :type: list[str]
        """

        self._excluded_docs = excluded_docs

    @property
    def remove_redundancies(self):
        """Gets the remove_redundancies of this TopicSummaryModel.  # noqa: E501

        If True, this option removes quasi-duplicates from the analysis. A quasi-duplicate would have the same NLP representation, but not necessarily the exact same text.  # noqa: E501

        :return: The remove_redundancies of this TopicSummaryModel.  # noqa: E501
        :rtype: bool
        """
        return self._remove_redundancies

    @remove_redundancies.setter
    def remove_redundancies(self, remove_redundancies):
        """Sets the remove_redundancies of this TopicSummaryModel.

        If True, this option removes quasi-duplicates from the analysis. A quasi-duplicate would have the same NLP representation, but not necessarily the exact same text.  # noqa: E501

        :param remove_redundancies: The remove_redundancies of this TopicSummaryModel.  # noqa: E501
        :type: bool
        """

        self._remove_redundancies = remove_redundancies

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(TopicSummaryModel, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, TopicSummaryModel):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
